﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Wpf;

namespace OriStarRasterWithNuGet
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {

        }

        private void winMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {

        }

        private void winMain_Closed(object sender, EventArgs e)
        {

        }
        private void WpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            string ThePath;
            string sInform;

            ThePath = string.Format("{0}", @"..\..\Data");

            wpfMap1.MapUnit = GeographyUnit.DecimalDegree;

            MrSidRasterLayer sidImageLayer = new MrSidRasterLayer(ThePath + @"\world.sid");

            sidImageLayer.DrawingException += SidImageLayer_DrawingException;
            sidImageLayer.DrawnException   += SidImageLayer_DrawnException;

            sidImageLayer.UpperThreshold = double.MaxValue;
            sidImageLayer.LowerThreshold = 0;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("SidImageLayer", sidImageLayer);
            wpfMap1.Overlays.Add(staticOverlay);

            try
            {
                wpfMap1.CurrentExtent = new RectangleShape(-118.098, 84.3, 118.098, -84.3);

                // uncomment of the next line results in exception of "Value cannot be null.\r\nParameter name: ptr"
                wpfMap1.CurrentExtent = staticOverlay.GetBoundingBox();

                // when the above line is commented an exception occurs sometime after the wpfMap1.Refresh
            }
            catch (Exception ex)
            {
                sInform = String.Format("Unable to GetBoundingBox{0}Message={1}", Environment.NewLine, ex.Message);
                System.Windows.MessageBox.Show(sInform, "WpfMap_Loaded", System.Windows.MessageBoxButton.OK, System.Windows.MessageBoxImage.Error);
                return;
            }

            wpfMap1.Refresh();
        }

        // this event is never encountered
        private void SidImageLayer_DrawingException(object sender, DrawingExceptionLayerEventArgs e)
        {
            string sInform;

            sInform = String.Format("Exception{0}Message={1}", Environment.NewLine, e.Exception.Message);
            System.Windows.MessageBox.Show(sInform, "SidImageLayer_DrawingException", System.Windows.MessageBoxButton.OK, System.Windows.MessageBoxImage.Error);
        }

        // this event is never encountered
        private void SidImageLayer_DrawnException(object sender, DrawnExceptionLayerEventArgs e)
        {
            string sInform;

            sInform = String.Format("Exception{0}Message={1}", Environment.NewLine, e.Exception.Message);
            System.Windows.MessageBox.Show(sInform, "SidImageLayer_DrawnException", System.Windows.MessageBoxButton.OK, System.Windows.MessageBoxImage.Error);
        }
    }
}
